﻿// This JS code will be processed inside a worker

// To achieve the black & white effect
var processBW = function (binaryData, l) {
    for (var i = 0; i < l; i += 4) {
        var r = binaryData[i];
        var g = binaryData[i + 1];
        var b = binaryData[i + 2];
        var luminance = r * 0.21 + g * 0.71 + b * 0.07;
        binaryData[i] = luminance;
        binaryData[i + 1] = luminance;
        binaryData[i + 2] = luminance;
    }
};

// To achieve the sepia effect
var processSepia = function (binaryData, l) {
    for (var i = 0; i < l; i += 4) {
        var r = binaryData[i];
        var g = binaryData[i + 1];
        var b = binaryData[i + 2];

        binaryData[i] = (r * 0.393) + (g * 0.769) + (b * 0.189);
        binaryData[i + 1] = (r * 0.349) + (g * 0.686) + (b * 0.168);
        binaryData[i + 2] = (r * 0.272) + (g * 0.534) + (b * 0.131);
    }
};

function readProtected(binaryData, l, offset) {
    if (offset < 0)
        offset = 0;

    if (offset >= l)
        offset = l - 1;

    return binaryData[offset];
}

// To achieve the blur effect   
var processBlur = function (binaryData, l, depth) {
    for (var i = 0; i < l; i += 4) {

        var moyR = 0;
        var moyG = 0;
        var moyB = 0;
        var count = 0;

        for (var around = -depth; around <= depth; around++) {
            var r = readProtected(binaryData, l, i + (around << 2));
            var g = readProtected(binaryData, l, i + (around << 2) + 1);
            var b = readProtected(binaryData, l, i + (around << 2) + 2);

            moyR += r;
            moyG += g;
            moyB += b;
            count++;
        }

        binaryData[i] = moyR / count;
        binaryData[i + 1] = moyG / count;
        binaryData[i + 2] = moyB / count;
    }
};